ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.25 by root, Tue Dec 28 18:03:47 2010 UTC vs.
Revision 1.42 by root, Sun May 1 10:03:29 2011 UTC

7CPAN=http://mirror.netcologne.de/cpan # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
8EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
9 9
10# perl build variables 10# perl build variables
11MAKE=make 11MAKE=make
12PERL_VERSION=5.12.2 # 5.8.9 is also a good choice 12PERL_VERSION=5.12.3 # 5.8.9 is also a good choice
13PERL_CC=cc 13PERL_CC=cc
14PERL_CONFIGURE="" # additional Configure arguments 14PERL_CONFIGURE="" # additional Configure arguments
15PERL_CCFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG" 15PERL_CCFLAGS="-g -DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=16376 -DNO_PERL_MALLOC_ENV -D_GNU_SOURCE -DNDEBUG"
16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
17 17
18ARCH="$(uname -m)" 18ARCH="$(uname -m)"
19 19
20case "$ARCH" in 20case "$ARCH" in
29esac 29esac
30 30
31# -Wl,--gc-sections makes it impossible to check for undefined references 31# -Wl,--gc-sections makes it impossible to check for undefined references
32# for some reason so we need to patch away the "-no" after Configure and before make :/ 32# for some reason so we need to patch away the "-no" after Configure and before make :/
33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug 33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
34PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition" 34#PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
35PERL_LDFLAGS=
35PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 36PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
36 37
37# some configuration options for modules 38# some configuration options for modules
38PERL_MM_USE_DEFAULT=1 39PERL_MM_USE_DEFAULT=1
40PERL_MM_OPT="MAN1PODS= MAN3PODS="
39#CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 41#CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
40EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0' 42EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0'
41export PERL_MM_USE_DEFAULT CORO_INTERFACE EV_EXTRA_DEFS 43export PERL_MM_USE_DEFAULT PERL_MM_OPT CORO_INTERFACE EV_EXTRA_DEFS
42 44
43# which extra modules to install by default from CPAN that are 45# which extra modules to install by default from CPAN that are
44# required by mkbundle 46# required by mkbundle
45STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage" 47STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage"
46 48
47# which extra modules you might want to install 49# which extra modules you might want to install
48EXTRA_MODULES="" 50EXTRA_MODULES=""
49 51
50# overridable functions 52# overridable functions
51preconfigure() { : ; } 53preconfigure() { : ; }
54patchconfig() { : ; }
52postconfigure() { : ; } 55postconfigure() { : ; }
53postbuild() { : ; } 56postbuild() { : ; }
54postinstall() { : ; } 57postinstall() { : ; }
55 58
56# now source user config, if any 59# now source user config, if any
63fi 66fi
64 67
65############################################################################# 68#############################################################################
66# support 69# support
67 70
68MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}"
69PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed 71PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
70 72
71unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG 73unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
74unset PERL_MB_OPT
72LC_ALL=C; export LC_ALL # just to be on the safe side 75LC_ALL=C; export LC_ALL # just to be on the safe side
76
77# prepend PATH - not required by staticperl itself, but might make
78# life easier when working in e.g. "staticperl cpan / look"
79PATH="$PERL_PREFIX/perl/bin:$PATH"
73 80
74# set version in a way that Makefile.PL can extract 81# set version in a way that Makefile.PL can extract
75VERSION=VERSION; eval \ 82VERSION=VERSION; eval \
76$VERSION=0.92 83$VERSION="1.22"
77 84
78BZ2=bz2 85BZ2=bz2
79BZIP2=bzip2 86BZIP2=bzip2
80 87
81fatal() { 88fatal() {
149 verblock <<EOF 156 verblock <<EOF
150downloading perl 157downloading perl
151to manually download perl yourself, place 158to manually download perl yourself, place
152perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL 159perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL
153trying $URL 160trying $URL
161
162either curl or wget is required for automatic download.
163curl is tried first, then wget.
154EOF 164EOF
155 165
156 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side 166 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side
157 curl -f >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 167 curl -f >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
158 || wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 168 || wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
165unpacking perl 175unpacking perl
166EOF 176EOF
167 177
168 mkdir -p unpack 178 mkdir -p unpack
169 rm -rf unpack/perl-$PERL_VERSION 179 rm -rf unpack/perl-$PERL_VERSION
170 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xfC - unpack \ 180 $BZIP2 -d <perl-$PERL_VERSION.tar.$BZ2 | ( cd unpack && tar xf - ) \
171 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking" 181 || fatal "perl-$PERL_VERSION.tar.$BZ2: error during unpacking"
172 chmod -R u+w unpack/perl-$PERL_VERSION 182 chmod -R u+w unpack/perl-$PERL_VERSION
173 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION 183 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION
174 rmdir -p unpack 184 rmdir -p unpack
175 fi 185 fi
176} 186}
227 237
228 # I hate them for this 238 # I hate them for this
229 grep -q -- -fstack-protector Configure && \ 239 grep -q -- -fstack-protector Configure && \
230 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure 240 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
231 241
232 preconfigure 242 # what did that bloke think
243 grep -q -- usedl=.define hints/darwin.sh && \
244 sedreplace '/^usedl=.define.;$/d' hints/darwin.sh
245
246 preconfigure || fatal "preconfigure hook failed"
233 247
234# trace configure \ 248# trace configure \
235 sh Configure -Duselargefiles \ 249 sh Configure -Duselargefiles \
236 -Uuse64bitint \ 250 -Uuse64bitint \
237 -Dusemymalloc=n \ 251 -Dusemymalloc=n \
239 -Uusethreads \ 253 -Uusethreads \
240 -Uuseithreads \ 254 -Uuseithreads \
241 -Uusemultiplicity \ 255 -Uusemultiplicity \
242 -Uusesfio \ 256 -Uusesfio \
243 -Uuseshrplib \ 257 -Uuseshrplib \
258 -Uinstallusrbinperl \
244 -A ccflags=" $PERL_CCFLAGS" \ 259 -A ccflags=" $PERL_CCFLAGS" \
245 -Dcc="$PERL_CC" \ 260 -Dcc="$PERL_CC" \
246 -Doptimize="$PERL_OPTIMIZE" \ 261 -Doptimize="$PERL_OPTIMIZE" \
247 -Dldflags="$PERL_LDFLAGS" \ 262 -Dldflags="$PERL_LDFLAGS" \
248 -Dlibs="$PERL_LIBS" \ 263 -Dlibs="$PERL_LIBS" \
268 sedreplace ' 283 sedreplace '
269 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 284 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
270 s/ *-fno-stack-protector */ /g 285 s/ *-fno-stack-protector */ /g
271 ' config.sh 286 ' config.sh
272 287
288 patchconfig || fatal "patchconfig hook failed"
289
273 sh Configure -S || fatal "Configure -S failed" 290 sh Configure -S || fatal "Configure -S failed"
274 291
275 postconfigure || fatal "postconfigure hook failed" 292 postconfigure || fatal "postconfigure hook failed"
276 293
277 touch staticstamp.configure 294 touch staticstamp.configure
295}
296
297write_shellscript() {
298 {
299 echo "#!/bin/sh"
300 echo "STATICPERL=\"$STATICPERL\""
301 echo "PERL_PREFIX=\"$PERL_PREFIX\""
302 echo "MAKE=\"$MAKE\""
303 cat
304 } >"$PERL_PREFIX/bin/$1"
305 chmod 755 "$PERL_PREFIX/bin/$1"
278} 306}
279 307
280build() { 308build() {
281 configure 309 configure
282 310
303EOF 331EOF
304 332
305 ln -sf "perl/bin/" "$STATICPERL/bin" 333 ln -sf "perl/bin/" "$STATICPERL/bin"
306 ln -sf "perl/lib/" "$STATICPERL/lib" 334 ln -sf "perl/lib/" "$STATICPERL/lib"
307 335
336 mkdir "$STATICPERL/patched"
337
308 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten 338 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
309 rm -rf "$PERL_PREFIX" # by this rm -rf 339 rm -rf "$PERL_PREFIX" # by this rm -rf
310 340
311 "$MAKE" install || fatal "make install: error while installing" 341 "$MAKE" install || fatal "make install: error while installing"
312 342
313 rcd "$PERL_PREFIX" 343 rcd "$PERL_PREFIX"
314 344
315 # create a "make install" replacement for CPAN 345 # create a "make install" replacement for CPAN
316 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF 346 write_shellscript SP-make-install-make <<'EOF'
317"$MAKE" || exit 347#CAT make-install-make.sh
318
319if find blib/arch/auto -type f | grep -q -v .exists; then
320 echo Probably an XS module, rebuilding perl
321 if "$MAKE" perl; then
322 mv perl "$PERL_PREFIX"/bin/perl~ \
323 && rm -f "$PERL_PREFIX"/bin/perl \
324 && mv "$PERL_PREFIX"/bin/perl~ "$PERL_PREFIX"/bin/perl
325 "$MAKE" -f Makefile.aperl map_clean
326 else
327 "$MAKE" -f Makefile.aperl map_clean
328 exit 1
329 fi
330fi
331
332"$MAKE" install UNINST=1
333EOF 348EOF
334 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install
335 349
350 # create a "patch modules" helper
351 write_shellscript SP-patch-postinstall <<'EOF'
352#CAT patch-postinstall.sh
353EOF
354
355 "$PERL_PREFIX/bin/SP-patch-postinstall"
356
336 # trick CPAN into avoiding ~/.cpan completely 357 # help to trick CPAN into avoiding ~/.cpan completely
337 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm" 358 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
338 359
360 # we call cpan with -MCPAN::MyConfig in this script, which
361 # is strictly unnecssary as we have to patch CPAN anyway,
362 # so consider it "for good measure".
339 "$PERL_PREFIX"/bin/perl -MCPAN -e ' 363 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e '
340 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'"); 364 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'");
341 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 365 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
342 CPAN::Shell->o (conf => q<init>); 366 CPAN::Shell->o (conf => q<init>);
343 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 367 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
344 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build"); 368 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build");
345 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs"); 369 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs");
346 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile"); 370 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile");
347 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources"); 371 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources");
348 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/cpan-make-install"); 372 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/SP-make-install-make");
349 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>); 373 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>);
350 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>); 374 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>);
375 CPAN::Shell->o (conf => q<prefer_installer>, "EUMM");
351 CPAN::Shell->o (conf => q<commit>); 376 CPAN::Shell->o (conf => q<commit>);
352 ' || fatal "error while initialising CPAN" 377 ' || fatal "error while initialising CPAN"
353 378
354 touch "$PERL_PREFIX/staticstamp.install" 379 touch "$PERL_PREFIX/staticstamp.install"
355 fi 380 fi
375installing modules from CPAN 400installing modules from CPAN
376$@ 401$@
377EOF 402EOF
378 403
379 for mod in "$@"; do 404 for mod in "$@"; do
380 "$PERL_PREFIX"/bin/perl -MCPAN -e 'notest install => "'"$mod"'"' \ 405 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e 'notest install => "'"$mod"'"' \
381 || fatal "$mod: unable to install from CPAN" 406 || fatal "$mod: unable to install from CPAN"
382 done 407 done
383 rm -rf "$STATICPERL/build" 408 rm -rf "$STATICPERL/build"
384} 409}
385 410
401 rcd $mod 426 rcd $mod
402 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1 427 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
403 "$MAKE" distclean >/dev/null 2>&1 428 "$MAKE" distclean >/dev/null 2>&1
404 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL" 429 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
405 "$MAKE" || fatal "$mod: error building module" 430 "$MAKE" || fatal "$mod: error building module"
406 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module" 431 "$PERL_PREFIX"/bin/SP-make-install-make install || fatal "$mod: error installing module"
407 "$MAKE" distclean >/dev/null 2>&1 432 "$MAKE" distclean >/dev/null 2>&1
408 exit 0 433 exit 0
409 ) || exit $? 434 ) || exit $?
410 done 435 done
411} 436}
443#CAT mkbundle 468#CAT mkbundle
444MKBUNDLE 469MKBUNDLE
445} 470}
446 471
447bundle() { 472bundle() {
473 MKBUNDLE="${MKBUNDLE:=$PERL_PREFIX/bin/SP-mkbundle}"
448 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create" 474 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
449 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE" 475 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE"
450 CACHE="$STATICPERL/cache" 476 CACHE="$STATICPERL/cache"
451 mkdir -p "$CACHE" 477 mkdir -p "$CACHE"
452 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@" 478 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@"
471 ;; 497 ;;
472 instcpan ) 498 instcpan )
473 ( instcpan "$@" ) || exit 499 ( instcpan "$@" ) || exit
474 exit 500 exit
475 ;; 501 ;;
502 perl )
503 ( install ) || exit
504 exec "$PERL_PREFIX/bin/perl" "$@"
505 exit
506 ;;
476 cpan ) 507 cpan )
477 ( install ) || exit 508 ( install ) || exit
478 "$PERL_PREFIX/bin/cpan" "$@" 509 exec "$PERL_PREFIX/bin/cpan" "$@"
479 exit 510 exit
480 ;; 511 ;;
481 mkbundle ) 512 mkbundle )
482 ( install ) || exit 513 ( install ) || exit
483 bundle "$@" 514 bundle "$@"

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines